#include "DragonW.inc"
.plugin string86
.org $8100

fight:
	ld a, (monster2)
	cp 255
	jr nz, otherdungeon
	ld hl, (playerpos)
	ld de, $0ffe
	sbc hl, de
	ld a, 64
	call _divHLbyA
	ld d, l
	add a, a
	ld e, a
	ld a, (xhalf)
	add a, e
	ld e, a
	call pickmonster
startfight:
	ld (curmon), a
	call getmoninfo
	ld bc, $0609
	ld de, $0304
	call makewindow
	ld hl, fightstring
	ld de, $1d36
	call drawstring
	call pause
	call ClearScreen
	call loadbattlescreen
	call drawmonster
	call drawstatwindow
	call announcemonster
	call pause
loop:
	call drawstatwindow
	jp showcommandwindow
nextloop:
	jp monsterattack
	jr loop

otherdungeon:
	cp 1
	jp z, sw_1
	cp 2
	jp z, sw_2
	cp 3
	jp z, sw_3
	cp 4
	jp z, sw_4
	cp 5
	jp z, sw_5
	cp 6
	jp z, sw_6
	cp 7
	jp z, sw_7
	cp 9
	jr z, sw_8
	ld a, 4
	call getrand
	add a, 25
	jp startfight
sw_8:
	call pick7
	jp startfight
sw_7:
	ld a, 4
	call getrand
	add a, 23
	jp startfight
sw_6:
	ld a, 5
	call getrand
	add a, 21
	jp startfight
sw_5:
	ld a, 5
	call getrand
	cp 2
	jr z, sw5a
	cp 3
	jr z, sw5b
	cp 4
	jr z, sw5c
	add a, 32
	jp startfight
sw5a:	
	ld a, 19
	jp startfight
sw5b:
	ld a, 14
	jp startfight
sw5c:
	ld a, 35
	jp startfight
sw_4:
	ld a, 4
	call getrand
	cp 3
	jr z, sw4a
	add a, 7
	jp startfight
sw4a:
	ld a, 11
	jp startfight
sw_3:
	ld a, 5
	call getrand
	cp 2
	jr z, sw3a
	cp 3
	jr z, sw3b
	cp 4
	jr z, sw3c
	add a, 30
	jp startfight
sw3a:
	ld a, 34
	jp startfight
sw3b:
	ld a, 7
	jp startfight
sw3c:
	ld a, 9
	jp startfight
sw_2:
	ld a, 3
	call getrand
	cp 2
	jr z, sw2a
	add a, 3
	jp startfight
sw2a:
	ld a, 29
	jp startfight
sw_1:
	ld a, 3
	call getrand
	cp 2
	jr z, sw2a
	add a, 4
	jp startfight

getrand:
	ld b, a
	ld a, r
	ld h, a
	ld l, a
	ld a, b
	jp _divHLbyA
monsterdead:
	call cleartext
	ld hl, fstring2
	ld de, $3a01
	call drawstring
	ld hl, (monname)
	ld de, $3a42
	call drawstring
	call pause
	call cleartext
	ld hl, fstring7
	ld de, $3a01
	call drawstring
	ld a, (mongold)
	ld l, a
	ld h, 0
	push hl
	ld de, (gold)
	add hl, de
	ld (gold), hl
	pop hl
	ld bc, $3a19
	call drawnumber
	ld hl, fstring8
	ld de, $3a40
	call drawstring
	ld a, (monexp)
	ld l, a
	ld h, 0
	push hl
	ld de, (exp)
	add hl, de
	ld (exp), hl
	pop hl
	ld bc, $3a59
	call drawnumber
	call drawstatwindow
	call pause
	ld hl, (exp)
	ld de, (nextlevel)
	call hlde
	cp 0
	ret z
	call cleartext
	ld hl, fstring9
	ld de, $3a01
	call drawstring
	call pause
	ld a, (level)
	dec a
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	add hl, hl
	ld e, a
	ld d, 0
	sbc hl, de
	ld de, leveldata
	add hl, de
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	inc hl
	ld (nextlevel), de
	ld a, (hl)
	ld (maxhp), a
	inc hl
	ld a, (hl)
	ld (maxmp), a
	inc hl
	ld a, (hl)
	cp 1
	call z, addspell2
	inc hl
	ld a, (hl)
	ld (strength), a
	inc hl
	ld a, (hl)
	ld (agility), a
	ld a, (level)
	inc a
	ld (level), a
	jp updatepower
addspell2:
	ld a, (spellnumber)
	inc a
	ld (spellnumber), a
	ret

youaredead:
	call cleartext
	ld hl, fstring6
	ld de, $3a01
	call drawstring
	xor a
	ld (level), a
	ld (maxhp), a
	ld (exp), a
	ld (gold), a
	call pause
	pop hl
	pop hl
	ret

loadbattlescreen:
	ld hl, battlebackground
	ld a, 56
	ld (loopvar), a
	ld a, 6
	ld (tempvar2), a
	ld a, 10
	ld (tempvar1), a
	ld de, $ca06
	call drawback
	ld hl, battlebackground+560
	ld de, $fc06
	jp drawback
drawback:
	ld a, (loopvar)
	ld b, a
dbloop1:
	push bc
	ld a, (tempvar1)
	ld b, a
dbloop2:
	ld a, (hl)
	ex de, hl
	ld (hl), a
	ex de, hl
	inc hl
	inc de
	djnz dbloop2
	pop bc
	push hl
	ld a, (tempvar2)
	ld l, a
	ld h, 0
	add hl, de
	ex de, hl
	pop hl
	djnz dbloop1
	ret

drawmonster:
	ld de, (mondata)
	ld a, (monflip)
	ld l, 0
	ld c, 0
	ld h, $fc
	ld b, $ca
	cp 1
	call z, flipcolors
	ld (fcolor1), hl
	ld (fcolor2), bc
	ex de, hl
	ld a, (hl)
	ld (tempvar1), a
	inc hl
	ld a, (hl)
	ld (tempvar2), a
	inc hl
	ld a, (hl)
	ld (loopvar), a
	inc hl
	ld a, (hl)
	inc hl
	inc hl
	ld (tempword1), hl
	dec hl
	ld e, a
	ld a, (hl)
	ld d, a
	ex de, hl
	push hl
	ld de, (fcolor1)
	add hl, de
	ex de, hl
	ld hl, (tempword1)
	call drawback
	pop de
	push hl
	ld hl, (fcolor2)
	add hl, de
	ex de, hl
	pop hl
	jp drawback
flipcolors:
	ld h, b
	ld b, $fc
	ret
fcolor1:
	.dw 0
fcolor2:
	.dw 0

pickmonster:
	ld c, 3
	ld a, e
	cp 33
	jr c, sq2
	cp 59
	jr nc, sq2
	ld a, d										;square 1
	cp 20
	jr c, sq2
	cp 50
	jr nc, sq2
	cp 40
	call nc, and1
	ld a, r
	and c
	ret
sq2:
	ld a, d
	cp 46
	jr nc, sq3
	ld a, e
	cp 87
	jr c, sq3
pick5:
	ld a, r
	and c
	add a, 4
	ret
sq3:
	ld a, e
	cp 29
	jr nc, sq4
	ld a, d
	cp 76
	jr c, sq4
	cp 104
	jr nc, sq4
pick3:
	call sqgetdivide
	ld a, 5
	call _divHLbyA
	add a, 10
	ret
sq4:
	ld a, e
	cp 24
	jr nc, sq5
	ld a, d
	cp 32
	jr c, sq5
	cp 75
	jr nc, sq5
	jr pick5
sq5:
	ld a, e
	cp 46
	jr nc, sq6
	cp 23
	jr c, sq6
	ld a, d
	cp 88
	jr nc, sq6
	cp 63
	jr c, sq6
	jr pick5
sq6:
	ld a, d
	cp 85
	jr c, sq7
	ld a,e
	cp 59
	jr nc, sq7
	call sqgetdivide
	ld a, 6
	call _divHLbyA
	add a, 15
	ret
sq7:
	ld a, d
	cp 77
	jr c, sq8
	ld a, e
	cp 88
	jr nc, sq8
pick7:
	call sqgetdivide
	ld a, 5
	call _divHLbyA
	add a, 20
	ret
sq8:
	ld a, d
	cp 94
	jr c, sq9
	jr pick3
sq9:
	ld a, d
	cp 41
	jr c, sq10
	ld a, e
	cp 69
	jr c, sq10
	ld a, r
	and c
	add a, 6
	ret
sq10:
	ld a, d
	cp 47
	jr c, sq11
	ld a, e
	cp 44
	jr c, sq11
	jr pick7
sq11:
	ld a, r
	and c
	inc a
	ret
and1:
	ld c, 1
sqgetdivide:
	ld a, r
	ld l, a
	ld h, 0
	ret

getmoninfo:
	ld h, 0
	ld l, a
	push hl
	add hl, hl
	add hl, hl
	add hl, hl
	pop de
	add hl, de
	add hl, de
	ld de, monsterstat
	add hl, de
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld (mondata), de
	inc hl
	ld a, (hl)
	ld (monflip), a
	inc hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a, (hl)
	ld d, a
	ld (monname), de
	inc hl
	ld a, (hl)
	ld (monhp), a
	ld (monmaxhp), a
	inc hl
	ld a, (hl)
	ld (monattack), a
	inc hl
	ld a, (hl)
	ld (mongold), a
	inc hl
	ld a, (hl)
	ld (monexp), a
	inc hl
	ld a, (hl)
	ld (monspell), a
	ret

announcemonster:
	ld hl, (monname)
	ld de, $3a01
	call drawstring
	ld hl, drawsnear
	ld de, $3a3a
	jp drawstring

showcommandwindow:
	call waitkey
	call cleartext
	ld a, (yousleep)
	cp 0
	jr z, godostuff
	ld hl, fstring16
	ld de, $3a01
	call drawstring
	call pause
	ld a, r
	and 1
	ld (yousleep), a
	jp nextloop
godostuff:
	ld bc, $0005
	ld de, $0607
	call makewindow
	ld hl, commandstring2
	ld de, $3a32
	call drawstring
	ld hl, fightstring2
	ld de, $3206
	call drawstring
	ld hl, runstring
	ld de, $3806
	call drawstring
	ld hl, spellstring
	ld de, $321d
	call drawstring
	ld hl, itemstring
	ld de, $381d
	call drawstring
	ld de, $3202
	ld (tempvar1), de
	ld de, 0
	ld (tempword3), de
	ld a, 5
	ld (xhalf), a
	xor a
	ld (keyvar), a
cwindowloop:
	call blinkmenu
	cp 0
	jr nz, cwindowloop2
	ld b, 60
	call keyloop
	cp 0
	jr nz, cwindowloop2
	jr cwindowloop
cwindowloop2:
	cp 1
	jr z, cdown
	cp 2
	jr z, cleft
	cp 3
	jr z, cright
	cp 4
	jr z, cup
	cp 6
	jr z, cect
	jr cwindowloop
cleft:
	ld a, $02
	ld (tempvar1), a
	jp cwindowloop
cright:
	ld a, $19
	ld (tempvar1), a
	jp cwindowloop
cdown:
	ld a, $38
	ld (tempvar2), a
	jp cwindowloop
cup:
	ld a, $32
	ld (tempvar2), a
	jp cwindowloop
cect:
	call waitkey
	ld a, (tempvar2)
	ld b, a
	ld a, (tempvar1)
	add a, b
	cp 52
	jr z, fightcommand
	cp 75
	jp z, spellcommand
	cp 58
	jp z, runcommand
	cp 81
	jp z, itemcommand
	jp nextloop

fightcommand:
	ld a, r
	push af
	call waitkey
	pop af
	ld c, 4
	and %01011010
	cp 90
	call z, excellentmove
	cp 0
	jr z, dodging
	ld hl, fstring1
	ld de, $3a32
	push bc
	call drawstring
	pop bc
	ld a, (attackpower)
	ld l, a
	ld h, 0
	ld a, c
	call _divHLbyA
	push hl
	add a, l
	ld b, a
	ld a, r
	add a, 100
	ld h, a
	ld l, a
	ld a, b
	call _divHLbyA
	pop hl
	add a, l
	dec a
	ld b, a
	ld a, r
	and %00000001
	add a, b
	ld l, a
	ld h, 0
	ld a, (curmon)
	cp 17
	call z, metalslimehit
	push hl
	ld bc, $3a69
	call drawnumber
	ld b, 10
fblinkloop:
	push bc
	ld a, (monflip)
	ld b, a
	ld a, 1
	sub b
	ld (monflip), a
	call drawmonster
	ld b, 4
	call keyloop
	pop bc
	djnz fblinkloop
	call pause
	pop hl
	ld a, (monhp)
	sub l
	jp c, monsterdead
	jp z, monsterdead
	ld (monhp), a
	jp nextloop
excellentmove:
	ld hl, fstring3
	ld de, $3a32
	call drawstring
	call pause
	ld c, 2
	ld a, c
	ret
dodging:
	ld hl, fstring4
	ld de, $3a32
	call drawstring
	call pause
	jp nextloop

itemcommand:
	call goitem
iteml2:
	call loadbattlescreen
	call drawmonster
	call drawstatwindow
	call cleartext
	jp nextloop

spellcommand:
	ld a, (youstops)
	cp 0
	jr z, castspell
	jp cwindowloop
castspell:
	call gospell
	jr iteml2

runcommand:
	call cleartext
	ld hl, fstring12
	ld de, $3a01
	call drawstring
	call pause
	ld a, r
	and %00000001
	cp 1
	jr z, blocked
	ret
blocked:
	ld hl, fstring13
	ld de, $3a01
	call drawstring
	call pause
	jp nextloop
metalslimehit:
	ld a, l
	and %00000001
	ld l, a
	ret

cleartext:
	ld hl, $ff80
	ld (hl), 0
	ld de, $ff81
	ld bc, 127
	ldir
	ld hl, $cd80
	ld (hl), 0
	ld de, $cd81
	ld bc, 127
	ldir
	ret

monsterattack:
	ld a, (monsleep)
	cp 0
	jr z, notasleep
	xor a
	ld (monsleep), a
	ld a, r
	and 1
	cp 0
	jr z, notasleep
	ld (monsleep), a
	call cleartext
	ld hl, fstring15
	ld de, $3a01
	call drawstring
	call pause
	jp loop
notasleep:
	call cleartext
	ld a, (itstops)
	cp 1
	jr z, nospell
	ld a, (monspell)
	cp 0
	jr z, nospell
	ld a, r
	and %00010000
	cp %00010000
	jp z, moncastspell
nospell:
	ld a, r
	push af
	call waitkey
	pop af
	and %01100101
	cp 101
	jp z, missed
	ld hl, (monname)
	ld de, $3a01
	call drawstring
	ld hl, fstring5
	ld de, $3a3a
	call drawstring
	ld a, (monattack)
	ld l, a
	ld h, 0
	ld a, 2
	call _divHLbyA
	push hl
	ld b, l
	ld a, r
	ld h, a
	ld a, b
	call _divHLbyA
	pop hl
	add a, l
	ld l, a
	push hl
	ld a, (defensepower)
	ld l, a
	ld h, 0
	ld a, 2
	call _divHLbyA
	ld b, l
	pop hl
	ld a, l
	sub b
	call c, setattack1
	ld b, a
	ld a, (hp)
	sub b
	jp z, youaredead
	jp c, youaredead
	ld (hp), a
	ld l, b
	ld h, 0
	ld bc, $3a69
	call drawnumber
	ld b, 2
	call flicker
	call pause
	call drawstatwindow
	jp loop
setattack1:
	ld a, 1
	ret
missed:
	ld hl, fstring10
	ld de, $3a01
	call drawstring
	call pause
	jp loop
moncastspell:
	ld hl, fstring17
	ld de, $3a01
	call drawstring
	ld de, $3a21
	ld a, (monspell)
	ld b, a
	and 1
	jr z, nohurt
	ld a, r
	and 1
	jp z, monhurt
nohurt:
	ld a, b
	and 2
	jr z, noheal
	ld a, r
	and 2
	jp z, monheal
noheal:
	ld a, b
	and 4
	jr z, nosleep
	ld a, (yousleep)
	cp 1
	jr z, nosleep
	ld a, r
	and 4
	jp z, moncastsleep
nosleep:
	ld a, b
	and 8
	jr z, nohealmore
	ld a, r
	and 1
	jp z, monhealmore
nohealmore:
	ld a, b
	and 16
	jr z, nohurtmore
	ld a, r
	and 2
	jp z, monhurtmore
nohurtmore
	ld a, b
	and 32
	jp z, nospell
	ld hl, spell5
	call drawstring
	call pause
	ld a, 1
	ld (youstops), a
	jp loop
monhurt:
	ld hl, spell2
	call drawstring
	call pause
	ld a, r
	and %00000111
	add a, 6
bothhurt:
	ld b, a
	ld a, (hp)
	sub b
	jp c, youaredead
	jp z, youaredead
	ld (hp), a
	jp loop
monhurtmore:
	ld hl, spell10
	call drawstring
	call pause
	ld a, r
	and %00001111
	add a, 20
	jr bothhurt
monheal:
	ld hl, spell1
	call drawstring
	call pause
	ld a, r
	and %00000111
	add a, 4
bothheal:
	ld b, a
	ld a, (monhp)
	add a, b
	ld b, a
	ld a, (monmaxhp)
	cp b
	call c, setmonhp
	ld a, b
	ld (monhp), a
	jp loop
setmonhp:
	ld b, a
	ret
monhealmore:
	ld hl, spell9
	call drawstring
	call pause
	ld a, r
	and %00001111
	add a, 20
	jr bothheal
moncastsleep:
	ld hl, spell3
	call drawstring
	call pause
	ld a, 1
	ld (yousleep), a
	jp loop
fightspells:
	ld a, b
	cp 1
	jr z, gohurt
	cp 2
	jr z, gosleep
	cp 9
	jr z, gohurtmore
	ld a, 1
	ld (itstops), a
	ret

gohurt:
	ld a, (mp)
	cp 2
	ret c
	sub 2
	ld (mp), a
	call cleartext
	ld a, r
	and %00000111
	add a, 8
hurtdiddly:
	push af
	ld l, a
	ld h, 0
	ld bc, $3a69
	call drawnumber
	ld hl, fstring14
	ld de, $3a01
	call drawstring
	pop af
	ld l, a
	ld a, (monhp)
	sub l
	jr c, godead
	jr z, godead
	ld (monhp), a
	jp pause
godead:
	pop hl
	jp monsterdead	
gohurtmore:
	ld a, (mp)
	cp 5
	ret c
	sub 5
	ld (mp), a
	call cleartext
	ld a, r
	and %00001111
	add a, 40
	jr hurtdiddly
gosleep:
	ld a, (mp)
	cp 2
	ret c
	sub 2
	ld (mp), a
	ld a, 1
	ld (monsleep), a
	ret

;INFORMATION
;--------------------------------------------------------------------

battlebackground:
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$18,$00,$08,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$08,$80,$00,$00,$00,$00,$00,$00,$40,$04,$20
 .db $00,$00,$00,$00,$00,$00,$08,$00,$03,$12,$10,$00,$00,$00,$00,$00
 .db $04,$13,$00,$09,$8C,$00,$00,$00,$00,$00,$00,$C0,$00,$78,$00,$00
 .db $00,$00,$00,$00,$00,$00,$01,$8C,$00,$00,$00,$00,$86,$00,$00,$00
 .db $01,$06,$00,$00,$00,$01,$08,$00,$00,$00,$03,$02,$00,$00,$00,$01
 .db $08,$00,$00,$00,$02,$46,$00,$00,$00,$00,$A4,$00,$00,$00,$02,$03
 .db $00,$00,$00,$40,$00,$80,$00,$00,$04,$21,$80,$00,$00,$71,$C0,$00
 .db $00,$00,$08,$C1,$80,$00,$00,$00,$0C,$00,$00,$00,$08,$C1,$80,$00
 .db $00,$00,$00,$00,$00,$00,$08,$CD,$80,$00,$00,$00,$00,$00,$00,$00
 .db $11,$4C,$C0,$00,$00,$00,$00,$00,$00,$00,$11,$CF,$C0,$00,$00,$00
 .db $00,$00,$01,$C0,$11,$CF,$C0,$00,$00,$00,$00,$00,$02,$60,$16,$BF
 .db $C0,$00,$00,$00,$00,$00,$04,$E0,$1F,$FD,$C0,$00,$00,$00,$00,$00
 .db $05,$F0,$2F,$EF,$C0,$00,$00,$00,$06,$00,$04,$58,$4B,$F6,$B0,$00
 .db $00,$00,$09,$00,$08,$7C,$9C,$AB,$F0,$00,$00,$00,$09,$00,$16,$3C
 .db $9D,$D9,$78,$00,$00,$00,$11,$00,$F5,$B6,$BF,$EA,$F8,$00,$00,$00
 .db $18,$81,$B9,$E7,$E3,$42,$7C,$00,$00,$00,$24,$81,$7C,$EB,$E0,$44
 .db $CE,$00,$00,$00,$24,$41,$7A,$B3,$F1,$0C,$4B,$00,$00,$00,$40,$21
 .db $70,$3A,$F2,$16,$C1,$00,$00,$00,$40,$73,$E6,$2F,$FA,$13,$C1,$80
 .db $00,$00,$93,$1A,$E6,$BC,$9E,$01,$70,$80,$00,$03,$60,$CB,$C7,$54
 .db $5A,$81,$75,$80,$00,$04,$C0,$47,$D5,$5C,$7A,$63,$3B,$00,$00,$03
 .db $E3,$67,$D7,$FE,$A0,$02,$3F,$00,$00,$00,$1F,$FB,$BF,$FF,$40,$02
 .db $2F,$00,$00,$00,$03,$CA,$3F,$FB,$85,$01,$02,$00,$00,$00,$00,$80
 .db $01,$C3,$0F,$E9,$02,$00,$00,$00,$00,$81,$02,$00,$08,$DD,$02,$00
 .db $00,$00,$01,$01,$01,$02,$04,$03,$86,$00,$00,$00,$01,$01,$01,$02
 .db $F8,$00,$78,$00,$00,$00,$00,$FE,$03,$32,$00,$00,$00,$00,$00,$00
 .db $00,$07,$FE,$CD,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0E,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$02,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$04,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$04
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$CE,$00,$00,$00,$00,$00,$00,$00,$00,$00,$F3,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$FB,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$FF,$80,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$80,$00,$00
 .db $00,$00,$00,$00,$00,$00,$7F,$C0,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$07,$40,$00,$00,$00,$00,$00,$03,$A4,$00,$07,$C0,$00,$00,$00
 .db $00,$00,$03,$FC,$00,$07,$60,$00,$00,$00,$00,$00,$03,$BE,$0B,$DF
 .db $FF,$80,$00,$00,$00,$00,$07,$FF,$00,$8D,$EF,$00,$00,$00,$00,$00
 .db $03,$E4,$00,$04,$40,$00,$00,$00,$00,$00,$02,$20,$00,$78,$00,$00
 .db $00,$00,$60,$00,$00,$00,$01,$EC,$00,$00,$00,$00,$71,$00,$00,$00
 .db $01,$86,$00,$00,$00,$00,$F7,$80,$00,$00,$03,$82,$00,$00,$00,$02
 .db $F7,$C0,$00,$00,$02,$4E,$00,$00,$00,$3F,$5B,$F0,$00,$00,$03,$1B
 .db $00,$00,$00,$BF,$FF,$78,$00,$00,$06,$A3,$80,$00,$00,$00,$0F,$00
 .db $00,$00,$0C,$D1,$80,$00,$00,$00,$02,$00,$00,$00,$0D,$C4,$80,$00
 .db $00,$00,$00,$00,$00,$00,$09,$E4,$80,$00,$00,$00,$00,$00,$00,$00
 .db $19,$64,$C0,$00,$00,$00,$00,$00,$00,$00,$19,$62,$C0,$00,$00,$00
 .db $00,$00,$01,$C0,$1B,$4A,$C0,$00,$00,$00,$00,$00,$03,$A0,$13,$9B
 .db $40,$00,$00,$00,$00,$00,$07,$20,$13,$FF,$40,$00,$00,$00,$00,$00
 .db $06,$50,$27,$FF,$C0,$00,$00,$00,$06,$00,$07,$F8,$5F,$FF,$F0,$00
 .db $00,$00,$0B,$00,$0F,$A4,$DF,$FF,$D0,$00,$00,$00,$0B,$00,$1F,$C4
 .db $91,$DB,$D8,$00,$00,$00,$13,$00,$FF,$4E,$B8,$CF,$88,$00,$00,$00
 .db $19,$81,$DE,$1F,$79,$0B,$F4,$00,$00,$00,$2D,$81,$8F,$1D,$35,$14
 .db $CE,$00,$00,$00,$2D,$C1,$9F,$4D,$11,$8C,$4F,$00,$00,$00,$46,$E1
 .db $9F,$CC,$03,$92,$89,$08,$11,$00,$52,$F3,$39,$D5,$0A,$91,$95,$8C
 .db $19,$00,$B7,$BA,$39,$C7,$06,$01,$12,$B5,$6B,$FF,$EB,$DA,$79,$EB
 .db $4E,$80,$75,$C2,$A5,$4F,$C3,$C4,$49,$E3,$7A,$62,$3B,$00,$00,$03
 .db $E7,$F5,$49,$81,$A0,$02,$3F,$00,$00,$00,$1F,$FF,$E3,$CF,$40,$00
 .db $2F,$00,$00,$00,$03,$FF,$FF,$FF,$95,$00,$02,$00,$00,$00,$00,$FF
 .db $DF,$FF,$2F,$E8,$02,$00,$00,$00,$00,$DF,$FF,$EF,$08,$DD,$42,$00
 .db $00,$00,$01,$F7,$FB,$F7,$04,$03,$86,$00,$00,$00,$01,$FF,$DF,$BF
 .db $F8,$00,$78,$00,$00,$00,$00,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00
 .db $00,$07,$FE,$CD,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$03,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$07,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$05,$00,$00,$00,$00,$00,$00,$00,$00,$00,$07
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$CE,$00,$00,$00,$00,$00,$00,$00,$00,$00,$B1,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$81,$80,$00,$00,$00,$00,$00,$00,$00,$00,$BC,$80,$00,$00
 .db $00,$00,$00,$00,$00,$00,$C2,$40,$00,$00,$00,$00,$00,$00,$00,$00

leveldata:
	.dw 23						;level 2
	.db 22, 0, 0, 5, 5
	.dw 47						;level 3
	.db 24, 6, 1, 7, 7
	.dw 110						;level 4
	.db 31, 16, 1, 7, 9
	.dw 220						;level 5
	.db 35, 20, 0, 12, 11
	.dw 450						;level 6
	.db 38, 23, 0, 16, 11
	.dw 800						;level 7
	.db 40, 25, 1, 18, 17
	.dw 1300					;level 8
	.db 46, 28, 0, 22, 20
	.dw 2100					;level 9
	.db 48, 32, 1, 26, 26
	.dw 2900					;level 10
	.db 49, 35, 1, 34, 33
	.dw 4000					;level 11
	.db 53, 42, 0, 39, 37
	.dw 5500					;level 12
	.db 57, 58, 1, 44, 40
	.dw 7500					;level 13
	.db 64, 64, 1, 47, 48
	.dw 10000					;level 14
	.db 71, 70, 0, 55, 55
	.dw 13000					;level 15
	.db 78, 72, 1, 62, 64
	.dw 16000					;level 16
	.db 83, 95, 0, 65, 70
	.dw 19000					;level 17
	.db 99, 96, 1, 70, 70
	.dw 22000					;level 18
	.db 115, 98, 0, 83, 74
	.dw 26000					;level 19
	.db 130, 104, 1, 85, 76
	.dw 30000					;level 20
	.db 138, 116, 0, 90, 78
	.dw 34000					;level 21
	.db 149, 122, 0, 93, 80
	.dw 38000					;level 22
	.db 158, 132, 0, 95, 80
	.dw 42000					;level 23
	.db 162, 136, 0, 97, 82
	.dw 46000					;level 25
	.db 166, 140, 0, 99, 83
	.dw 50000					;level 26
	.db 170, 144, 0, 101, 85
	.dw 54000					;level 27
	.db 174, 148, 0, 103, 87
	.dw 58000					;level 28
	.db 178, 152, 0, 105, 89
	.dw 62000					;level 29
	.db 182, 156, 0, 107, 91
	.dw 65535					;level 30
	.db 186, 160, 0, 109, 93
	.dw 65535					;level 31
	.db 190, 164, 0, 111, 95
	.dw 65535					;level 32
	.db 194, 168, 0, 113, 97
drawsnear:
	.text "draws near!"
fightstring:
	.text "FIGHT!"
curmon:
	.db 0
runstring:
	.text "RUN"
fightstring2:
	.text "FIGHT"
commandstring2:
	.text "Command?"
fstring1:
	.text "You attack for       "
fstring3:
	.text "Excellent move!"
fstring4:
	.text "It is dodging!"
fstring2:
	.text "Thou hast killed the"
fstring5:
	.text "attacks for"
fstring6:
	.text "Thou art dead."
fstring7:
	.text "GOLD +"
fstring8:
	.text "EXP. +"
fstring9:
	.text "Thou hast gained a level."
fstring10:
	.text "It lunges and misses thee!"
fstring11:
	.text "You chant the spell of HEAL"
fstring12:
	.text "You start to run away..."
fstring13:
	.text "But are blocked in the front!"
fstring14:
	.text "You cast it for"
fstring15:
	.text "It is still asleep"
fstring16:
	.text "Thou art still asleep."
fstring17:
	.text "It casts"
mondata:
	.dw 0
monflip:
	.db 0
monname:
	.dw 0
monhp:
	.db 0
mongold:
	.db 0
monexp:
	.db 0
monattack:
	.db 0
monsleep:
	.db 0
monspell:
	.db 0
monmaxhp:
	.db 0
yousleep:
	.db 0
youstops:
	.db 0
itstops:
	.db 0
#include "monsterdata.asm"

.end
