#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Dragon W. 86 Walkthrough",0

ProgStart:
	call _clrLCD
	call _runindicoff
	call drawscreen
loop:
	ld b, 1
	call keyloop
	cp 1
	call z, down1
	cp 4
	call z, up1
	cp 5
	jr nz, loop
	ret

up1:
	ld hl, (linenumber)
	ld a, l
	cp 0
	ret z
	dec hl
	dec hl
	ld (linenumber), hl
	call drawscreen
	xor a
	ret

down1:
	ld hl, (linenumber)
	ld a, l
	cp 100
	ret z
	inc hl
	inc hl
	ld (linenumber), hl
	call drawscreen
	xor a
	ret
	
drawscreen:
	ld hl, topscreen
	ld de, $0001
	call drawstring
	ld hl, bottomscreen
	ld de, $3601
	call drawstring
	ld hl, (linenumber)
	add hl, hl
	ld de, lines
	add hl, de
	ld b, 8
dwloop:
	push hl
	ld a, (hl)
	ld e, a
	inc hl
	ld a , (hl)
	ld d, a
	ld a, 9
	sub b
	ld l, 0
	ld h, a
	add hl, hl
	push bc
	push hl
	add hl, hl
	pop bc
	add hl, bc
	ex de, hl
	push hl
	push de
	call clearline
	pop de
	pop hl
	call drawstring
	pop bc
	pop hl
	inc hl
	inc hl
	djnz dwloop
	ret

keyloop:
	xor a												;most of games processing goes here, because it doubles as a null loop
	ld (keyvar), a
	ld (keycounter), a

keyloopb:
	ld c, b
	ld b, 50
keyloop2:
 	ld a,%1111110
	out (1),a
 	nop
 	in a,(1)
	ld e, 1
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
	ld a,%00111111
	out (1), a
	nop
	in a, (1)
	and %01000000
	call z, ldkey
	inc e
	in a, (1)
	and %00100000
	call z, ldkey
	inc e
	ld a,%01111101
	out (1), a
	nop
	in a, (1)
	ld l, a
	and %00000010
	call z, ldkey
	inc e
	ld a, l
	and %00000100
	call z, ldkey
	inc e
	ld a,%01011111
	out (1), a
	nop
	in a,(1)
	and %10000000
	call z, ldkey
	djnz keyloop2
	ld b, c
	djnz keyloopb
	ld a, (keyvar)
	ret

ldkey:
	ld d, a
	ld a, e
	ld (keyvar), a
	ld a, (keycounter)
	cp 30
	jr z, staykey
	inc a
	ld (keycounter), a
	ld a, 0
	ld (keyvar), a
staykey:
	ld a, d
	ret
; keys:
; 1=down
; 2=left
; 3=right
; 4=up
; 5=exit
; 6=2nd
; 7=plus
; 8=minus
; 9=alpha
keycounter:
	.db 0
keyvar:
	.db 0
linenumber:
	.dw 0

drawstring:														;simple memory solutions
	ld (_penCol), de
	jp _vputs

topscreen:
	.text "Dragon Warrior 86 Walkthrough"
bottomscreen:
	.text "By Thomas Williamson, Biobytes Soft."
clearline:
	ex de, hl
	ld a, 16
	call _divHLbyA
	ld de, $fc00
	add hl, de
	push hl
	pop de
	inc de
	xor a
	ld (hl), a
	ld bc, 95
	ldir
	ret
	
	

lines:
	.dw info2, info3, info4, info5, info6, info7, space, info8, info9, info10, space
	.dw info11, info12, space, info13, info14, info15, space, info16, info17, info18, info19, space, info20
	.dw info21, info22, space, info23, info24, space, info25, info26, info27, info28, space, info29, info30
	.dw info31, info32, info33, info34, info35, info36, space, info37, info38, info39, space, info40
	.dw info41, info42, info43, info44, space, info45, info46, info47, space, info48, info49, info50
	.dw info51, space, info52, info53, info54, info55, space, info56, info57, space, info58, info59, info60
	.dw info61, info62, info63, info64, space, info65, info66, info67, space, info68, info69, info70, space
	.dw info71, info72, info73, space, info74, info75, info76, info77, info78, info79, info80, space
	.dw info81, info82, info83, info84, info85, space, info86, info87, info88, space

info2:
	.text "--------------------------------"
info3:
	.text "Step-by-Step Instructions"
info4:
	.text "---------------"
info5:
	.text "1) After talking with the king, go"
info6:
	.text "east and buy a club, then save for"
info7:
	.text "leather armor"
info8:
	.text "2) By level 4, you should be able"
info9:
	.text "to traverse Erdrick's Cave north of"
info10:
	.text "Tantegel. Make sure you have torches!"
info11:
	.text "3) Use Erdrick's Tablet to find out"
info12:
	.text "your quest"
info13:
	.text "4) Now, you can go to Garinham, in the"
info14:
	.text "NE corner of the world. There you can"
info15:
	.text "buy chain mail."
info16:
	.text "5) By level 7 or 8 you can travel to"
info17:
	.text "Kol on the Eastern continent. Search 4"
info18:
	.text "steps south of the bath for the fairy"
info19:
	.text "flute."
info20
	.text "6) Save up for Full Plate now, and"
info21
	.text "wait tilll you are level 10 before the"
info22
	.text "next step"
info23
	.text "7) Now go through the Swamp Cave and"
info24
	.text "beware the east side!"
info25
	.text "8) You're now on the south continent!"
info26
	.text "Now travel to Rimuldar a little south"
info27
	.text "to find keys, and Magic Armor and the"
info28
	.text "Broad Sword"
info29
	.text "9) Once you're about level 16 feel"
info30
	.text "safe to travel the area far south of"
info31
	.text "Garinham. There you will find a town"
info32
	.text "in the desert, Hauksness. Here there"
info33
	.text "are very powerful enemies. Travel to"
info34
	.text "the SE side and find the secluded"
info35
	.text "tile of trees, you'll know them when"
info36
	.text "an Axed Knight attacks you!"
info37
	.text "10) Search the ground in the trees"
info38
	.text "to find Erdrick's Armor, which will"
info39
	.text "serve you through the end."
info40
	.text "11) When you are feeling powerful"
info41:
	.text "enough, feel free to travel to"
info42:
	.text "Cantlin SE of Hauksness. Be sure"
info43
	.text "to take the southernmost then"
info44
	.text "northernmost bridges!"
info45
	.text "12) Before reaching Cantlin, Golem"
info46
	.text "will attack you. Don't worry, he's"
info47
	.text "not very hard."
info48
	.text "13) At Cantlin you will soon find"
info49
	.text "you can purchase many items,"
info50
	.text "especially the Flame Sword, and"
info51
	.text "the Silver Shield."
info52
	.text "14) Now, (make sure you have a"
info53
	.text "key) you can save the Princess."
info54
	.text "You'll find her on the east side"
info55
	.text "of the Swamp Cave"
info56
	.text "15) To defeat the Dragonlord, you"
info57
	.text "have to get three items."
info58
	.text "16) To obtain the Staff of Rain,"
info59
	.text "find the Silver Harp in Garinham's"
info60
	.text "dungeon and trade it with the"
info61
	.text "wizard in the shrine to the east"
info62
	.text "of Kol. You must have four keys"
info63
	.text "or two keys and the Outside spell"
info64
	.text "to get out of this dungeon!"
info65
	.text "17) To get the Stones of Sunlight"
info66
	.text "find the basement of Tantegel"
info67
	.text "Castle. It's not that hard."
info68
	.text "18) To get Erdrick's Token, search"
info69
	.text "in the middle of the large swamp"
info70
	.text "south of Cantlin."
info71
	.text "19) Now speak with the man in"
info72
	.text "shrine south of Rimuldar. He will"
info73
	.text "give you the Rainbow Drop."
info74
	.text "20) Use the Rainbow drop at the"
info75
	.text "very eastern side of Rimuldar's"
info76
	.text "continent to be transported to"
info77
	.text "the Dragonlord's island two"
info78
	.text "tiles away. Using the drop here"
info79
	.text "on the westernmost side will"
info80
	.text "transport you back."
info81
	.text "21) In the Dragonlord's castle"
info82
	.text "go to the stairs behind his"
info83:
	.text "throne in the first room. Now"
info84:
	.text "you can find Erdrick's Sword"
info85:
	.text "and the Dragonlord."
info86:
	.text "22) Return to the castle and"
info87:
	.text "speak with the king to end"
info88:
	.text "the game. Good Luck!"
space:
	.text " "
.end
